Article 43578 of comp.os.vms:
Newsgroups: comp.os.vms
Path: jac.zko.dec.com!pa.dec.com!decwrl!hookup!yeshua.marcam.com!MathWorks.Com!europa.eng.gtefsd.com!howland.reston.ans.net!cs.utexas.edu!uunet!ncrgw2.ncr.com!ncrhub2!ncr-sd!lcpd2!wildcat.SanDiegoCA.NCR.COM!rays
From: rays@wildcat.SanDiegoCA.NCR.COM (Ray Steel)
Subject: Re: Question regarding LIB$INSERT_TREE
Message-ID: <Cw8AH8.9wF@lcpd2.SanDiegoCA.NCR.COM>
Sender: news@lcpd2.SanDiegoCA.NCR.COM (News Administrator)
Nntp-Posting-Host: wildcat.sandiegoca.ncr.com
Organization: NCR LCPD San Diego
Date: Fri, 16 Sep 1994 15:17:32 GMT
Lines: 294

Here's some example code that does the balanced binary tree 'Remove Node'.
I actually have code for all the tree routines as my application runs
on Unix as well as VMS. If you want it all, E-Mail me and we'll work out a
deal!

Ray Steel
-----------------------------------------------------------
typedef
struct  _tre_node
        {
        struct  _tre_node       *left;
        struct  _tre_node       *right;
        short                   balance;
        short                   spare;
        } TRE_NODE;























long
RSTreRemove(head, data, callback, node, param)
TRE_NODE	**head;
void		*data;
long		(*callback) ();
TRE_NODE	**node;
void		*param;
{
	long	status = SS_NORMAL;
	TreRemove(head, data, callback, node, param, &status);
	return(status);
}












static
int
RemoveR(head1, head2)
TRE_NODE	**head1;
TRE_NODE	**head2;
{
	TRE_NODE	*t0,
			*t1,
			*t2 = *head1;

	if (t2->left)
	{
		if (RemoveR(&t2->left, head2))
		{
			if (!++t2->balance)
				return(1);
			if (t2->balance > 1)
			{
				t1 = t2->right;
				if (t1->balance >= 0)
				{
					t2->right = t1->left;
					t1->left = t2;
					*head1 = t1;
					if (t1->balance > 0)
					{
						t2->balance = 0;
						t1->balance = 0;
						return(1);
					}
					t2->balance = 1;
					t1->balance = -1;
					return(0);
				}
				else
				{
					t0 = t1->left;
					t1->left = t0->right;
					t0->right = t1;
					t2->right = t0->left;
					t0->left = t2;
					t2->balance = 0;
					t1->balance = 0;
					if (t0->balance > 0)
						t2->balance = -1;
					else if (t0->balance < 0)
						t1->balance = 1;
					t0->balance = 0;
					*head1 = t0;
					return(1);
				}
			}
		}
	}
	else
	{
		*head2 = t2;
		*head1 = t2->right;
		return(1);
	}

	return(0);
}









static
int
RemoveL(head1, head2)
TRE_NODE	**head1;
TRE_NODE	**head2;
{
	TRE_NODE	*t0,
			*t1,
			*t2 = *head1;
	if (t2->right)
	{
		if (RemoveL(&t2->right, head2))
		{
			if (!--t2->balance)
				return(1);
			if (t2->balance < -1)
			{
				t1 = t2->left;
				if (t1->balance <= 0)
				{
					t2->left = t1->right;
					t1->right = t2;
					*head1 = t1;
					if (t1->balance < 0)
					{
						t2->balance = 0;
						t1->balance = 0;
						return(1);
					}
					t2->balance = -1;
					t1->balance = 1;
					return(0);
				}
				else
				{
					t0 = t1->right;
					t1->right = t0->left;
					t0->left = t1;
					t2->left = t0->right;
					t0->right = t2;
					t2->balance = 0;
					t1->balance = 0;
					if (t0->balance < 0)
						t2->balance = 1;
					else if (t0->balance > 0)
						t1->balance = -1;
					t0->balance = 0;
					*head1 = t0;
					return(1);
				}
			}
		}
	}
	else
	{
		*head2 = t2;
		*head1 = t2->left;
		return(1);
	}
	return(0);
}











static
TreRemove(head, data, callback, node, param, status)
TRE_NODE	**head;
void		*data;
long		(*callback) ();
TRE_NODE	**node;
void		*param;
long		*status;
{
	long		i0;
	TRE_NODE	*t0,
			*t1,
			*t2 = *head;
	if (!t2)
	{
		*status = RS_MSG_KEYNOTFOU;
		return(0);
	}
	i0 = callback(data, t2, param);
	if (i0 > 0)
	{
		if (!TreRemove(&t2->right, data, callback, node, param, status))
			return(0);
		if (!--t2->balance)
			return(1);
		if (t2->balance >= -1)
			return(0);
		t0 = t2->left;
		if (t0->balance <= 0)
		{
			t2->left = t0->right;
			t0->right = t2;
			*head = t0;
			if (t0->balance < 0)
			{
				t2->balance = 0;
				t0->balance = 0;
				return(1);
			}
			t2->balance = -1;
			t0->balance = 1;
			return(0);
		}
	
		t1 = t0->right;
		t0->right = t1->left;
		t1->left = t0;
		t2->left = t1->right;
		t1->right = t2;
		t2->balance = 0;
		t0->balance = 0;
		if (t1->balance < 0)
			t2->balance = 1;
		else if (t1->balance > 0)
			t0->balance = -1;
		t1->balance = 0;
		*head = t1;
		return(1);
	}

	if (i0 < 0)
	{
		if (!TreRemove(&t2->left, data, callback, node, param, status))
			return(0);
		if (!++t2->balance)
			return(1);
		if (t2->balance <= 1)
			return(0);
		t1 = t2->right;
		if (t1->balance >= 0)
		{
			t2->right = t1->left;
			t1->left = t2;
			*head = t1;
			if (t1->balance > 0)
			{
				t2->balance = 0;
				t1->balance = 0;
				return(1);
			}
			t2->balance = 1;
			t1->balance = -1;
			return(0);
		}
		t0 = t1->left;
		t1->left = t0->right;
		t0->right = t1;
		t2->right = t0->left;
		t0->left = t2;
		t2->balance = 0;
		t1->balance = 0;
		if (t0->balance > 0)
			t2->balance = -1;
		else if (t0->balance < 0)
			t1->balance = 1;
		t0->balance = 0;
		*head = t0;
		return(1);
	}

	*node = t2;
	if (t2->left)
	{
		if (t2->right)
		{
			if (t2->balance > 0)
			{
				i0 = RemoveR(&t2->right, &t0);
				t0->left = t2->left;
				t0->right = t2->right;
				t0->balance = t2->balance;
				*head = t2 = t0;

				if (!i0 || --t2->balance)
					return(0);
				return(1);
			}
			i0 = RemoveL(&t2->left, &t0);
			t0->left = t2->left;
			t0->right = t2->right;
			t0->balance = t2->balance;
			*head = t2 = t0;

			if (!i0 || ++t2->balance)
				return(0);

			return(1);
		}
		*head = t2->left;
		return(1);
	}
	if (t2->right)
	{
		*head = t2->right;
		return(1);
	}
	*head = 0;
	return(1);
}


