/*
** COPYRIGHT (c) 1990, 1992, 1994 BY
** DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASSACHUSETTS.
** ALL RIGHTS RESERVED.
**
** THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND COPIED
** ONLY  IN  ACCORDANCE  OF  THE  TERMS  OF  SUCH  LICENSE  AND WITH THE
** INCLUSION OF THE ABOVE COPYRIGHT NOTICE. THIS SOFTWARE OR  ANY  OTHER
** COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY
** OTHER PERSON.  NO TITLE TO AND  OWNERSHIP OF THE  SOFTWARE IS  HEREBY
** TRANSFERRED.
**
** THE INFORMATION IN THIS SOFTWARE IS  SUBJECT TO CHANGE WITHOUT NOTICE
** AND  SHOULD  NOT  BE  CONSTRUED  AS A COMMITMENT BY DIGITAL EQUIPMENT
** CORPORATION.
**
** DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE  OR  RELIABILITY OF ITS
** SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.
*/

/*
**++
**  Facility:
**
**	Examples
**
**  Version: V1.0
**
**  Abstract:
**
**	Example of working with the $BRKTHRU service.
**
**	This program demonstrates the $BRKTHRUW system service; this
**	program sends a harcoded message to a hardcoded username; this
**	demo uses the GENERAL broadcast class with a five second timeout.
**
**  Author:
**	Steve Hoffman
**
**  Creation Date:  1-Jan-1990
**
**  Modification History:
**--
*/

#include <brkdef.h>
#include <descrip.h>
#include <ssdef.h>
#include <starlet.h>
#include <stsdef.h>

main()
    {
    unsigned long int carcon = 0x20;
    unsigned long int retstat;
    unsigned short int iosb[4];

    $DESCRIPTOR( trg, "HOFFMAN" );
    $DESCRIPTOR( msg, "This is a $BRKTHRU test" );

    /*
    //  And now we do what we came here for...  The $brkthru.
    */
    retstat = sys$brkthruw( 0, &msg,
	&trg, BRK$C_USERNAME, iosb,
	&carcon, 0, BRK$C_GENERAL, &5, 0, 0 );
    if  (!$VMS_STATUS_SUCCESS( retstat )) return retstat;
    if  (!$VMS_STATUS_SUCCESS( iosb[0] )) return iosb[0];

    return SS$_NORMAL;
    }
