//  Copyright 2006 Hewlett-Packard Development Company, L.P.
//
//  An example of retrieving the system ID (SID) via $getsyi.
//
//  Author: Stephen Hoffman, HP OpenVMS Engineering
//

#include <stdio.h>
#include <ssdef.h>
#include <starlet.h>
#include <stsdef.h>
#include <syidef.h>
#define ITEMLISTMAX 10

main()
    {
    int RetStat;
    int Sid;
    int i;
    int iosb[2];
    struct ItemList3
	{ 
	unsigned short int BufferLength;
	unsigned short int ItemCode;
	void *BufferAddress;
	unsigned short int *ReturnLength;
	} il3[ITEMLISTMAX];

    i = 0;
    il3[i].BufferLength	    = sizeof( int );
    il3[i].ItemCode	    = SYI$_SID;
    il3[i].BufferAddress    = &Sid;
    il3[i++].ReturnLength   = 0;
    il3[i].BufferLength	    = 0;
    il3[i].ItemCode	    = 0;
    il3[i].BufferAddress    = 0;
    il3[i++].ReturnLength   = 0;

    RetStat = sys$getsyiw( 0, 0, 0, il3, iosb, 0, 0 );
    if ( !($VMS_STATUS_SUCCESS( RetStat )))
	return RetStat;
    if ( !($VMS_STATUS_SUCCESS( iosb[0] )))
	return iosb[0];

    printf("SID: 0x0%X\n");

    return SS$_NORMAL;
    }
