  typedef unsigned char Boolean;
  enum _boolEnum { false=0, true=1};

  Boolean IsLeapYear(int y)
  {
    if(y % 400 == 0) return true;
    if(y % 100 == 0) return false;
    if(y % 4 == 0) return true;
    return false;
  }

The more compact macro version is:

  #define ISLEAPYEAR(y) ((y) % 400 == 0 || ((y) % 100 != 0 && (y) % 4 == 0))
