#include <acedef.h>
#include <descrip.h>
#include <ssdef.h>
#include <starlet.h>
#include <stdio.h>
#include <stsdef.h>
#include <lib$routines.h>

#define MAXACE 256

int main(int argc, char **argv )
  {
  int RetStat;
  $DESCRIPTOR( AceText, "(AUDIT=SECURITY,ACCESS=DELETE+CONTROL+SUCCESS)");
  struct dsc$descriptor AceBufferDesc;
  char AceBuffer[MAXACE];
  char *AceAuditName;

  AceBufferDesc.dsc$w_length  = MAXACE;
  AceBufferDesc.dsc$b_dtype   = DSC$K_DTYPE_T;
  AceBufferDesc.dsc$b_class   = DSC$K_CLASS_S;
  AceBufferDesc.dsc$a_pointer = AceBuffer;

  RetStat = sys$parse_acl( &AceText, &AceBufferDesc, 0, 0, 0 );
  if (!$VMS_STATUS_SUCCESS( RetStat ))
    lib$signal( RetStat );

  AceAuditName = ((struct acedef *)AceBuffer)->ace$t_auditname;
  printf("%16.16s\n", AceAuditName );

  return SS$_NORMAL;
  }
