#include <ctype.h>
#include <descrip.h>
#include <lib$routines.h>
#include <libdtdef.h>
#include <ssdef.h>
#include <starlet.h>
#include <stdio.h>
#include <string.h>
#include <stsdef.h>

bias( void *TimDscInV, void *SortQuadOutV, void *TimDscOutV )
    {
    int RetStat;
    int TimCtx = 0;
    char TimBuf[23+1];
    int dd, yy;
    char mmm[4], m1, m2, m3;
    $DESCRIPTOR( TimFmt, "|!Y4-!MN0-!D0|!H04:M0:S0:.C2|" );
    struct dsc$descriptor TimDsc = { 0, DSC$K_DTYPE_D, DSC$K_CLASS_S, 0};
    struct dsc$descriptor *TimDscIn = TimDscInV;
    struct dsc$descriptor *TimDscOut = TimDscOutV;

    if (( TimDscIn->dsc$w_length != 9 ) && ( TimDscIn->dsc$w_length != 8 ) )
	return SS$_IVTIME;
    memcpy( TimBuf, TimDscIn->dsc$a_pointer, TimDscIn->dsc$w_length );
    TimBuf[TimDscIn->dsc$w_length] = 0;
    sscanf(TimBuf,"%d-%c%c%c-%d", &dd, &m1, &m2, &m3, &yy );
    if ( yy > 99 )
	return SS$_IVTIME;
    yy = yy > 57 ? yy + 1900 : yy + 2000;
    sprintf( TimBuf, "%d-%c%c%c-%d", dd, m1, m2, m3, yy );
    TimDsc.dsc$a_pointer = TimBuf;
    TimDsc.dsc$w_length = TimDscIn->dsc$w_length + 2;
    RetStat = sys$bintim( TimDscIn, SortQuadOutV ); 

    RetStat = lib$init_date_time_context( &TimCtx, &LIB$K_OUTPUT_FORMAT, &TimFmt );
    if (!$VMS_STATUS_SUCCESS( RetStat )) return RetStat;
    RetStat = lib$format_date_time( TimDscOut, SortQuadOutV, &TimCtx, &dd, &LIB$M_DATE_FIELDS );
    if (!$VMS_STATUS_SUCCESS( RetStat )) return RetStat;

    return SS$_NORMAL;
    }
main()
   {
    int RetStat;
    int TimeQuad[2];
    struct dsc$descriptor_d TimeDsc = { 0, DSC$K_DTYPE_D, DSC$K_CLASS_S, 0};

    $DESCRIPTOR( TimeRaw1, "1-Jan-00" );
    $DESCRIPTOR( TimeRaw2, "1-Jan-20" );
    $DESCRIPTOR( TimeRaw3, "1-Jan-40" );
    $DESCRIPTOR( TimeRaw4, "1-Jan-60" );
    $DESCRIPTOR( TimeRaw5, "1-Jan-80" );

    RetStat = lib$sget1_dd( &23,  &TimeDsc );
    if (!$VMS_STATUS_SUCCESS( RetStat )) return RetStat;

    RetStat = bias( &TimeRaw1, TimeQuad, &TimeDsc );
    if (!$VMS_STATUS_SUCCESS( RetStat )) return RetStat;
    RetStat = lib$put_output( &TimeDsc );
    if (!$VMS_STATUS_SUCCESS( RetStat )) return RetStat;

    RetStat = bias( &TimeRaw2, TimeQuad, &TimeDsc );
    if (!$VMS_STATUS_SUCCESS( RetStat )) return RetStat;
    RetStat = lib$put_output( &TimeDsc );
    if (!$VMS_STATUS_SUCCESS( RetStat )) return RetStat;

    RetStat = bias( &TimeRaw3, TimeQuad, &TimeDsc );
    if (!$VMS_STATUS_SUCCESS( RetStat )) return RetStat;
    RetStat = lib$put_output( &TimeDsc );
    if (!$VMS_STATUS_SUCCESS( RetStat )) return RetStat;

    RetStat = bias( &TimeRaw4, TimeQuad, &TimeDsc );
    if (!$VMS_STATUS_SUCCESS( RetStat )) return RetStat;
    RetStat = lib$put_output( &TimeDsc );
    if (!$VMS_STATUS_SUCCESS( RetStat )) return RetStat;

    RetStat = bias( &TimeRaw5, TimeQuad, &TimeDsc );
    if (!$VMS_STATUS_SUCCESS( RetStat )) return RetStat;
    RetStat = lib$put_output( &TimeDsc );
    if (!$VMS_STATUS_SUCCESS( RetStat )) return RetStat;

    RetStat = lib$sfree1_dd( &TimeDsc );
    return 1;
    }
