#module	EXAMPLE "SRH X1.0-000"
#pragma builtins

/*
** COPYRIGHT (c) 1992 BY
** DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASSACHUSETTS.
** ALL RIGHTS RESERVED.
**
** THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND COPIED
** ONLY  IN  ACCORDANCE  OF  THE  TERMS  OF  SUCH  LICENSE  AND WITH THE
** INCLUSION OF THE ABOVE COPYRIGHT NOTICE. THIS SOFTWARE OR  ANY  OTHER
** COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY
** OTHER PERSON.  NO TITLE TO AND  OWNERSHIP OF THE  SOFTWARE IS  HEREBY
** TRANSFERRED.
**
** THE INFORMATION IN THIS SOFTWARE IS  SUBJECT TO CHANGE WITHOUT NOTICE
** AND  SHOULD  NOT  BE  CONSTRUED  AS A COMMITMENT BY DIGITAL EQUIPMENT
** CORPORATION.
**
** DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE  OR  RELIABILITY OF ITS
** SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.
*/

/*
**++
**  Facility:
**
**	Examples
**
**  Version: V1.0
**
**  Abstract:
**
**	show how to get display information via $QIO to WSA0:.
**	(This device is pointed to by the DECW$DISPLAY logical.)
**
**  Author:
**	CSC via usenet
**
**  Creation Date:  DEC-1991
**
**  Modification History:
**--
*/
/**********************************************************/
/* Program:  WSQIO.C                                      */
/* Purpose:  To show how to get display information.      */
/* Date   :  December 1991                                */
/* Note   :  This is undocumented and unsupported code    */
/**********************************************************/
#include stdio
#include iodef
#include descrip

#define IO$M_WS_DISPLAY         64
#define DECW$C_WS_DSP_NODE       1
#define DECW$C_WS_DSP_TRANSPORT  2
#define DECW$C_WS_DSP_SERVER     3
#define DECW$C_WS_DSP_SCREEN     4

main()
  {
    int status;
    short channel, iosb[4], retlen;
    char info[80];
    $DESCRIPTOR (device, "DECW$DISPLAY");

    status = sys$assign (&device, &channel, 0, 0);
    if (!(status & 1)) lib$stop(status);

    status = sys$qiow (0, channel, IO$_SENSEMODE | IO$M_WS_DISPLAY,
                       iosb, 0, 0, info, sizeof(info) - 1,
                       DECW$C_WS_DSP_NODE, 0, 0, 0);
    if (!(status & 1)) lib$stop(status);
    if (!(iosb[0] & 1)) lib$stop(iosb[0]);

    info[iosb[2]] = '\0';
    printf ("The node name is:  %s\n",info);
  }

-- 
Bruce Tanner        (310) 860-2451 x 596    Tanner@Cerritos.EDU
Cerritos College    Norwalk, CA             DoD #0161  NOMAD #007


