$!
$! Scans all entries in all specified queue(s).
$! Wildcards in the queue name are permitted.
$! Displays the contents of the specified queues.
$! Can be customized to alter or delete queue entries.
$!
$  IF p1 .EQS. ""
$  THEN 
$    read sys$command/prompt="Queue name? " inputqname
$  else
$    inputqname = p1
$  endif
$  tmp = f$getqui("")
$qloop:
$  qname = f$getqui("display_queue","queue_name",inputqname)
$  if qname .eqs. "" then exit
$  write sys$output ""
$  write sys$output "Queue: ", qname
$jloop:
$  jname = f$getqui("display_job","job_name",,"all_jobs")
$  if jname .eqs. "" then goto qloop
$  entry = f$getqui("display_job","entry_number",,"freeze_context,all_jobs")
$  user = f$getqui("display_job","username",,"freeze_context,all_jobs")
$  user = f$edit(user,"COLLAPSE,UPCASE")
$  write sys$output "    entry: ''entry':
$  write sys$output "    user:  ''user'"
$
$  ! insert DELETE/ENTRY or other queue command here:
$  !  eg:
$  !  if user .eqs. "username" then DELETE/ENTRY='entry'
$
$ goto jloop
