$!  Queue hack to allow [name] to check on the current status of
$!  the server batch jobs (hopefully) running in the batch queues.
$!
$!  17-Apr-1990	    Voice Products  Steve Hoffman
$!
$!
$ Write sys$output "[product] demonstrations on NODE1::."
$!
$ if .not. f$getsyi("CLUSTER_MEMBER","NODE1")
$ Then
$   Write sys$output "  NODE1:: is *not* in the VAXcluster."
$   Write sys$output " "
$   Write sys$output "** No batch queues are running on NODE1::."
$ Else
$   Write sys$output "  NODE1:: is in the VAXcluster."
$   Write sys$output " "
$   Write sys$output "Checking the demonstration batch queues:"
$ EndIf
$!
$! Check the first queue
$!
$ Write sys$output " "
$ x = F$GETQUI("CANCEL_OPERATION")
$!
$ qnam = F$GETQUI("DISPLAY_QUEUE","QUEUE_NAME",-
    "NODE1_product","BATCH,WILDCARD,FREEZE_CONTEXT")
$ qrun = F$GETQUI("DISPLAY_QUEUE","EXECUTING_JOB_COUNT",-
    "NODE1_product","BATCH,WILDCARD")
$ jtot = 0
$LOOP1:
$ jnam = F$GETQUI("DISPLAY_JOB","JOB_NAME",,"ALL_JOBS,FREEZE_CONTEXT")
$ jnum = F$GETQUI("DISPLAY_JOB","ENTRY_NUMBER",,"ALL_JOBS,FREEZE_CONTEXT")
$ jpqs = F$GETQUI("DISPLAY_JOB","PEND_QUEUE_STATE",,"ALL_JOBS")
$ if jpqs
$ Then
$   Write sys$output "** [job] (NODE1_product) queue is not running."
$   jtot = 0
$   goto LOOP1_END
$ EndIf
$ if jnam .eqs. "BATCH_product" then $ jtot = jtot + 1
$ if jnam .nes. "" then goto LOOP1
$!
$LOOP1_END:
$ if qrun .ne. 0
$ then
$   write sys$output "  Number of [job] jobs executing: ''qrun'"
$ EndIf
$ if jtot .eq. 0
$ then
$   write sys$output "  <no [job] jobs ready>"
$ else
$   write sys$output "  Total number of [job] jobs: ''jtot'"
$ endif
$!
$! Check the second queue
$!
$ Write sys$output " "
$ x = F$GETQUI("CANCEL_OPERATION")
$!
$ qnam = F$GETQUI("DISPLAY_QUEUE","QUEUE_NAME",-
    "NODE1_ANSWER","BATCH,WILDCARD,FREEZE_CONTEXT")
$ qrun = F$GETQUI("DISPLAY_QUEUE","EXECUTING_JOB_COUNT",-
    "NODE1_ANSWER","BATCH,WILDCARD")
$ jtot = 0
$LOOP2:
$ jnam = F$GETQUI("DISPLAY_JOB","JOB_NAME",,"ALL_JOBS,FREEZE_CONTEXT")
$ jpqs = F$GETQUI("DISPLAY_JOB","PEND_QUEUE_STATE",,"ALL_JOBS")
$ if jpqs
$ Then
$   Write sys$output "** [job] (NODE1_ANSWER) queue is not running."
$   jtot = 0
$   goto LOOP2_END
$ EndIf
$ if jnam .eqs. "START_TELECOM" then $ jtot = jtot + 1
$ if jnam .nes. "" then goto LOOP2
$!
$LOOP2_END:
$ if qrun .ne. 0
$ then
$   write sys$output "  Number of [job] jobs executing: ''qrun'"
$ EndIf
$ if jtot .eq. 0
$ then
$   write sys$output "  <no [job] jobs ready>"
$ else
$   write sys$output "  Total number of [job] jobs: ''jtot'"
$ endif
$!
$ Write sys$output " "
$ Write sys$output "Check completed."
$!
$ Write sys$output " "
$ Exit
