/*
** COPYRIGHT (c) 1994 BY
** DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASSACHUSETTS.
** ALL RIGHTS RESERVED.
**
** THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND COPIED
** ONLY  IN  ACCORDANCE  OF  THE  TERMS  OF  SUCH  LICENSE  AND WITH THE
** INCLUSION OF THE ABOVE COPYRIGHT NOTICE. THIS SOFTWARE OR  ANY  OTHER
** COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY
** OTHER PERSON.  NO TITLE TO AND  OWNERSHIP OF THE  SOFTWARE IS  HEREBY
** TRANSFERRED.
**
** THE INFORMATION IN THIS SOFTWARE IS  SUBJECT TO CHANGE WITHOUT NOTICE
** AND  SHOULD  NOT  BE  CONSTRUED  AS A COMMITMENT BY DIGITAL EQUIPMENT
** CORPORATION.
**
** DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE  OR  RELIABILITY OF ITS
** SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.
*/

/*
**++
**  Facility:
**
**	Examples
**
**  Version: V1.0
**
**  Abstract:
**
**	Example of a tape unload operation.
**
**  Author:
**	Steve Hoffman
**
**  Creation Date:  26-Aug-1994
**
**  Modification History:
**--
*/

#include    iodef
#include    ssdef
#include    stsdef
#include    descrip
#include    starlet
#include    lib$routines

main()
    {
    int lRetstat;
    unsigned short int qIosb[4];
    unsigned short int sChannel;
    $DESCRIPTOR( dTape, "MKA500:");

    lRetstat = sys$assign( &dTape, &sChannel, 0, 0 );
    if ( !$VMS_STATUS_SUCCESS( lRetstat )) return lRetstat;

    lRetstat = sys$qiow( 0, sChannel, IO$_PACKACK, qIosb, 0, 0,
	0, 0, 0, 0, 0, 0 );
    if ( !$VMS_STATUS_SUCCESS( lRetstat )) return lRetstat;
    if ( !$VMS_STATUS_SUCCESS( qIosb[0] )) return qIosb[0];

    lRetstat = sys$qiow( 0, sChannel, IO$_UNLOAD, qIosb, 0, 0,
	0, 0, 0, 0, 0, 0 );
    if ( !$VMS_STATUS_SUCCESS( lRetstat )) return lRetstat;
    if ( !$VMS_STATUS_SUCCESS( qIosb[0] )) return qIosb[0];

    return lRetstat;
    }
