$
$! MBXDEMO.COM
$! Builds the MBXDEMO component images.
$
$! the following is the object/image for the main process.
$
$ cc mbxdemo -
        /Define=("MASTER=1") -
	/Prefix=ALL -
        /DEBUG/NoOptimize/Object=MBXDEMO_MASTER
$
$! the following is the object/image for the detached process.
$! Do *not* link this image with debug...
$
$ cc mbxdemo -
        /Define=("SLAVE=1") -
	/Prefix=ALL -
        /noDEBUG/Optimize/Object=MBXDEMO_SLAVE
$
$ Link mbxdemo_master/debug
$ Link mbxdemo_slave/nodebug
$
$! Set up the logical names required for run-time operation...
$! Use the group logical name table, as it is visible both to 
$! the current (master) and to the created (slave) process...
$
$ mycom = f$parse(f$environment("PROCEDURE"),,,,"NO_CONCEAL")
$ mbxdemo_slave_exe = f$parse("MBXDEMO_SLAVE.EXE;0",mycom) - ";0"
$ define/group/nolog MBXDEMO_SLAVE_EXE 'mbxdemo_slave_exe'
$ mbxdemo_slave_log = f$parse("MBXDEMO_SLAVE.LOG;0",mycom) - ";0"
$ define/group/nolog MBXDEMO_SLAVE_LOG 'mbxdemo_slave_log'
$ mbxdemo_slave_dat = f$parse("MBXDEMO_SLAVE.DAT;0",mycom) - ";0"
$ define/group/nolog MBXDEMO_SLAVE_DAT 'mbxdemo_slave_dat'

$ Exit
$
