/*
// This program displays the current OpenVMS license date.
// (The license date is used for most (all?) system-integrated
// license PAK checks.)
// $ cc/decc x/prefix=all
// $ link x/sysexe
*/

#include <descrip.h>
#include <lib$routines.h>
#include <ssdef.h>
#include <starlet.h>
#include <stdio.h>
#include <stsdef.h>
#define MAXASCTIMLEN 23
extern __int64 VMS$GQ_LICENSE_DATE;
extern long VMS$GL_LICENSE_VERSION;
main()
    {
    int RetStat;
    struct dsc$descriptor FormattedTimeDesc;
    char FormattedTimeBuffer[MAXASCTIMLEN];

    /*
    //	Convert time from binary to ASCII.
    */
    FormattedTimeDesc.dsc$w_length = MAXASCTIMLEN;
    FormattedTimeDesc.dsc$b_dtype = DSC$K_DTYPE_T;
    FormattedTimeDesc.dsc$b_class = DSC$K_CLASS_S;
    FormattedTimeDesc.dsc$a_pointer = FormattedTimeBuffer;

    RetStat = sys$asctim( 0, &FormattedTimeDesc, &VMS$GQ_LICENSE_DATE, 0 );
    if (!$VMS_STATUS_SUCCESS( RetStat )) return RetStat;
    RetStat = lib$put_output( &FormattedTimeDesc );
    if (!$VMS_STATUS_SUCCESS( RetStat )) return RetStat;

    return SS$_NORMAL;
    }
